"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard").default;

exports.__esModule = true;
var _exportNames = {};
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireWildcard(require("react"));

var _basicSetup = require("@codemirror/basic-setup");

Object.keys(_basicSetup).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _basicSetup[key]) return;
  exports[key] = _basicSetup[key];
});

var _state = require("@codemirror/state");

Object.keys(_state).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _state[key]) return;
  exports[key] = _state[key];
});

var _view = require("@codemirror/view");

Object.keys(_view).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _view[key]) return;
  exports[key] = _view[key];
});

var _useCodeMirror2 = require("./useCodeMirror");

Object.keys(_useCodeMirror2).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _useCodeMirror2[key]) return;
  exports[key] = _useCodeMirror2[key];
});

var _dark = require("./theme/dark");

var _light = require("./theme/light");

var _jsxRuntime = require("react/jsx-runtime");

var _excluded = ["className", "value", "selection", "extensions", "onChange", "theme", "height", "minHeight", "maxHeight", "width", "minWidth", "maxWidth"];

var _default = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
  var className = props.className,
      value = props.value,
      selection = props.selection,
      _props$extensions = props.extensions,
      extensions = _props$extensions === void 0 ? [] : _props$extensions,
      onChange = props.onChange,
      _props$theme = props.theme,
      theme = _props$theme === void 0 ? 'light' : _props$theme,
      _props$height = props.height,
      height = _props$height === void 0 ? '' : _props$height,
      _props$minHeight = props.minHeight,
      minHeight = _props$minHeight === void 0 ? '' : _props$minHeight,
      _props$maxHeight = props.maxHeight,
      maxHeight = _props$maxHeight === void 0 ? '' : _props$maxHeight,
      _props$width = props.width,
      width = _props$width === void 0 ? '' : _props$width,
      _props$minWidth = props.minWidth,
      minWidth = _props$minWidth === void 0 ? '' : _props$minWidth,
      _props$maxWidth = props.maxWidth,
      maxWidth = _props$maxWidth === void 0 ? '' : _props$maxWidth,
      other = (0, _objectWithoutPropertiesLoose2.default)(props, _excluded);
  var editor = (0, _react.useRef)(null);

  var defaultThemeOption = _view.EditorView.theme({
    "&": {
      height: height,
      minHeight: minHeight,
      maxHeight: maxHeight,
      width: width,
      minWidth: minWidth,
      maxWidth: maxWidth
    }
  });

  var getExtensions = [_basicSetup.basicSetup, defaultThemeOption];
  theme === 'light' ? getExtensions.push(_light.defaultLightThemeOption) : getExtensions.push(_dark.defaultDarkThemeOption);
  getExtensions = getExtensions.concat(extensions);

  var _useCodeMirror = (0, _useCodeMirror2.useCodeMirror)({
    container: editor.current,
    value: value,
    selection: selection,
    onChange: onChange,
    extensions: getExtensions
  }),
      state = _useCodeMirror.state,
      view = _useCodeMirror.view,
      container = _useCodeMirror.container,
      setContainer = _useCodeMirror.setContainer;

  (0, _react.useImperativeHandle)(ref, function () {
    return {
      editor: container,
      state: state,
      view: view
    };
  });
  (0, _react.useEffect)(function () {
    setContainer(editor.current);
    return function () {
      if (view) {
        view.destroy();
      }
    }; // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);
  (0, _react.useEffect)(function () {
    if (view) {
      view.dispatch({
        effects: _state.StateEffect.reconfigure.of(getExtensions)
      });
    } // eslint-disable-next-line react-hooks/exhaustive-deps

  }, [theme, extensions, height, height, minHeight, maxHeight, width, minWidth, maxWidth]);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)("div", (0, _extends2.default)({
    ref: editor,
    className: "cm-theme-" + theme + " " + (className || '')
  }, other));
});

exports.default = _default;
module.exports = exports.default;
//# sourceMappingURL=index.js.map